//+------------------------------------------------------------------+
//|                                                       #dtosc.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_color1 Red
#property indicator_color2 Orange
#property indicator_color3 LimeGreen
#property indicator_color4 Lime
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_level1 30
#property indicator_level2 70

//
//
//
//
//

   extern string TimeFrame     = "Current time frame";
   extern int    RsiPeriod1    = 13;
   extern int    StochPeriod1  =  8;
   extern int    SmoothPeriod1 =  5;
   extern int    SmoothMode1   = MODE_SMA;
   extern int    RsiPeriod2    = 13;
   extern int    StochPeriod2  = 14;
   extern int    SmoothPeriod2 =  5;
   extern int    SmoothMode2   = MODE_SMA;
   extern int    RsiPeriod3    = 13;
   extern int    StochPeriod3  = 25;
   extern int    SmoothPeriod3 =  5;
   extern int    SmoothMode3   = MODE_SMA;
   extern int    RsiPeriod4    =  0;
   extern int    StochPeriod4  =  0;
   extern int    SmoothPeriod4 =  0;
   extern int    SmoothMode4   = MODE_SMA;
   extern string UniqueID      = "dtosc1";
   extern bool   ShowZone      = true;
   extern color  ZoneColor     = C'255,238,210';
   extern bool   Interpolate     = true;

//
//
//
//
//

double dtosc1[];
double dtosc2[];
double dtosc3[];
double dtosc4[];
double storsi1[];
double storsi2[];
double storsi3[];
double storsi4[];

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;
string shortName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,dtosc1);
   SetIndexBuffer(1,dtosc2);
   SetIndexBuffer(2,dtosc3);
   SetIndexBuffer(3,dtosc4);
   SetIndexBuffer(4,storsi1);
   SetIndexBuffer(5,storsi2);
   SetIndexBuffer(6,storsi3);
   SetIndexBuffer(7,storsi4);

   //
   //
   //
   //
   //
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame=="returnBars";     if (returnBars)     return(0);
   calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   shortName = timeFrameToString(timeFrame)+" "+UniqueID+" ("+RsiPeriod1+","+StochPeriod1+","
                                                             +RsiPeriod2+","+StochPeriod2+","
                                                             +RsiPeriod3+","+StochPeriod3+","
                                                             +RsiPeriod4+","+StochPeriod4+")";
   IndicatorShortName(shortName);
return(0);
}
int deinit() { ObjectDelete(UniqueID); return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][4];
int start()
{
   int i,n,r,counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { dtosc1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
      int maxlen = MathMax(StochPeriod1,StochPeriod2);
          maxlen = MathMax(StochPeriod3,maxlen);
          maxlen = MathMax(StochPeriod4,maxlen);
         for(i=limit,r=Bars-i-1; i>=0; i--,r++)
         {
            if (RsiPeriod1>1) work[r][0] = iRSI(NULL,0,RsiPeriod1,PRICE_CLOSE,i);
            if (RsiPeriod2>1) work[r][1] = iRSI(NULL,0,RsiPeriod2,PRICE_CLOSE,i);
            if (RsiPeriod3>1) work[r][2] = iRSI(NULL,0,RsiPeriod3,PRICE_CLOSE,i);
            if (RsiPeriod4>1) work[r][3] = iRSI(NULL,0,RsiPeriod4,PRICE_CLOSE,i);
               double ll1 = work[r][0]; double hh1 = work[r][0];
               double ll2 = work[r][1]; double hh2 = work[r][1];
               double ll3 = work[r][2]; double hh3 = work[r][2];
               double ll4 = work[r][3]; double hh4 = work[r][3];
                  for (int k=1; k<maxlen; k++)
                  {
                     if (k<StochPeriod1) { ll1 = MathMin(ll1,work[r-k][0]); hh1 = MathMax(hh1,work[r-k][0]); }
                     if (k<StochPeriod2) { ll2 = MathMin(ll2,work[r-k][1]); hh2 = MathMax(hh2,work[r-k][1]); }
                     if (k<StochPeriod3) { ll3 = MathMin(ll3,work[r-k][2]); hh3 = MathMax(hh3,work[r-k][2]); }
                     if (k<StochPeriod4) { ll4 = MathMin(ll4,work[r-k][3]); hh4 = MathMax(hh4,work[r-k][3]); }
                  }
               if (hh1!=ll1) storsi1[i] = 100.0*(work[r][0]-ll1)/(hh1-ll1); else storsi1[i] = 0;
               if (hh2!=ll2) storsi2[i] = 100.0*(work[r][1]-ll2)/(hh2-ll2); else storsi2[i] = 0;
               if (hh3!=ll3) storsi3[i] = 100.0*(work[r][2]-ll3)/(hh3-ll3); else storsi3[i] = 0;
               if (hh4!=ll4) storsi4[i] = 100.0*(work[r][3]-ll4)/(hh4-ll4); else storsi4[i] = 0;
         }   
         for(i=limit; i>=0; i--)
         {
            if (RsiPeriod1>1) dtosc1[i] = iMAOnArray(storsi1,0,SmoothPeriod1,0,SmoothMode1,i);
            if (RsiPeriod2>1) dtosc2[i] = iMAOnArray(storsi2,0,SmoothPeriod2,0,SmoothMode2,i);
            if (RsiPeriod3>1) dtosc3[i] = iMAOnArray(storsi3,0,SmoothPeriod3,0,SmoothMode3,i);
            if (RsiPeriod4>1) dtosc4[i] = iMAOnArray(storsi4,0,SmoothPeriod4,0,SmoothMode4,i);
         }      
         return(0);
   }      

   //
   //
   //
   //
   //

   if (ShowZone)
   {
      int window = WindowFind(shortName);
         ObjectCreate(UniqueID,OBJ_RECTANGLE,window,0,0,0,0);
            ObjectSet(UniqueID,OBJPROP_PRICE1,  0);
            ObjectSet(UniqueID,OBJPROP_PRICE2,100);
            ObjectSet(UniqueID,OBJPROP_TIME1,iTime(NULL,timeFrame,0));
            ObjectSet(UniqueID,OBJPROP_TIME2,iTime(NULL,timeFrame,0)+timeFrame*60-1);
            ObjectSet(UniqueID,OBJPROP_BACK,true);
            ObjectSet(UniqueID,OBJPROP_COLOR,ZoneColor);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         if (RsiPeriod1>1) dtosc1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod1,StochPeriod1,SmoothPeriod1,SmoothMode1,RsiPeriod2,StochPeriod2,SmoothPeriod2,SmoothMode2,RsiPeriod3,StochPeriod3,SmoothPeriod3,SmoothMode3,RsiPeriod4,StochPeriod4,SmoothPeriod4,SmoothMode4,0,y);
         if (RsiPeriod1>1) dtosc2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod1,StochPeriod1,SmoothPeriod1,SmoothMode1,RsiPeriod2,StochPeriod2,SmoothPeriod2,SmoothMode2,RsiPeriod3,StochPeriod3,SmoothPeriod3,SmoothMode3,RsiPeriod4,StochPeriod4,SmoothPeriod4,SmoothMode4,1,y);
         if (RsiPeriod1>1) dtosc3[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod1,StochPeriod1,SmoothPeriod1,SmoothMode1,RsiPeriod2,StochPeriod2,SmoothPeriod2,SmoothMode2,RsiPeriod3,StochPeriod3,SmoothPeriod3,SmoothMode3,RsiPeriod4,StochPeriod4,SmoothPeriod4,SmoothMode4,2,y);
         if (RsiPeriod1>1) dtosc4[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod1,StochPeriod1,SmoothPeriod1,SmoothMode1,RsiPeriod2,StochPeriod2,SmoothPeriod2,SmoothMode2,RsiPeriod3,StochPeriod3,SmoothPeriod3,SmoothMode3,RsiPeriod4,StochPeriod4,SmoothPeriod4,SmoothMode4,3,y);
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

            datetime time = iTime(NULL,timeFrame,y);
               for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(k = 1; k < n; k++)
               {
                  if (RsiPeriod1>1) dtosc1[i+k] = dtosc1[i] + (dtosc1[i+n] - dtosc1[i])*k/n;
                  if (RsiPeriod2>1) dtosc2[i+k] = dtosc2[i] + (dtosc2[i+n] - dtosc2[i])*k/n;
                  if (RsiPeriod3>1) dtosc3[i+k] = dtosc3[i] + (dtosc3[i+n] - dtosc3[i])*k/n;
                  if (RsiPeriod4>1) dtosc4[i+k] = dtosc4[i] + (dtosc4[i+n] - dtosc4[i])*k/n;
               }                  
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}   

